#include "happystats.h"

u_long get_ds_value (char *dsname);

void Alerts_Treshold_Engine()
{
	u_short i ;
	alertPtr alert ;
	u_long value ;
	char buf[BUFSIZ] ;

	alert  = World.Alerts.AlertTreshold ;
	for (i=0;i<World.Alerts.nbAlertTreshold;i++)
	{
		value = get_ds_value(alert->dsname) ;
		if (value >= alert->treshold)
		{ 

			alert->nb_hit_treshold++ ;

			if (alert->nb_hit_treshold == 3 ) 
			{
					if ( (alert->last_alert + World.Alerts.interval) < World.timestamp )
					{ 
						sprintf(buf,"DS : %s  value : %lu treshold : %lu\n",alert->dsname,value,alert->treshold);
						Happy_sendmail(alert->mailsubject,buf,alert->mailrcpt);
						alert->last_alert = World.timestamp ;
						
					} else { 
						alert->nb_hit_treshold = 0 ; /* Reset number of hit treshold it's not time to send an alert */
					}

			} 
				
		} else if (alert->nb_hit_treshold > 0)
			alert->nb_hit_treshold=0;

		alert = alert->next; 
	}
		
}


u_long get_ds_value (char *dsname)
{
	struct Gds *DS ;
	u_short i ;

	DS = World.GDS ;
	for (i=0;i<World.nbGDS;i++)
	{
		if (strcmp(dsname,DS->dsname_ptr) == 0)
			return(*DS->dscount_ptr);

		DS = DS->next ;
	}

	return(0);
}

/* Match a parsed logline against Alerts  registered rules 
 * Send an warning if match */
void Alert_Rules_Engine () 
{ 

	u_short  i, rc ;	
	alertPtr cur = NULL ;

	cur = World.Alerts.AlertRules ;
    	
	for (i = 0; i < World.Alerts.nbAlertRules; i++) 
	{ 
		rc = 0 ;
		
		if (cur->re_host == NULL ) {
			rc++; /* No regexp so match in any case */ 
		} else { 
			if (regmatch(World.parsedline.hostname,cur->re_host) > 0 ) { 
				rc++;
			} else { 
					cur = cur->next ;
					continue ; 
			}
				 
		}
		
		if (cur->re_program == NULL)  {
			rc++; 
		} else { 
			if (regmatch(World.parsedline.program,cur->re_program) > 0) {
				rc++;
			} else { 
					cur = cur->next ;
					continue ; 
			}

		}
		

		if (cur->re_action == NULL )  {
			rc++; 
		} else { 
			if (regmatch(World.parsedline.action,cur->re_action) > 0) {
				rc++;
			} else { 
					cur = cur->next ;
					continue ; 
			}
		}

			

		/* The 3 regexp match send an alert */
		if (rc == 3) { 
	 		/* Send the alert */
			Happy_sendmail(cur->mailsubject,World.fh.line,cur->mailrcpt);
			printf("-------- RULES ----------\n");
			/*
			printf("J'ai vu un gros minet !!!\n%s\n",World.fh.line);
			printf("tiens je vais emmerder : %s \n",cur->mailrcpt);
			printf("et je ais lui raconter ma life\n%s\n",cur->mailsubject);
			printf("-------------------------\n");*/
		}
		
		cur = cur->next ;

	}

}
