
/* Includes */
#include "happystats.h"
#include "cgi.h"

int main (int argc,char **argv) {

	char outputimg[_POSIX2_LINE_MAX];
	int X = 0, T= 0, rc = 0;
	graphPtr graph ;

	u_long day = 3600 * 24 ;
	u_long week  = 3600*24*7 ;
	u_long month = 3600*24*31 ;
	u_long year  = 3600*24*365 ;
	u_long prev_time = 0 ;
	time_t cur_time = 0 ;
	u_long next_time = 0 ;
	/* u_long cur_period = 0 ; */
	char *form , *url; 
	u_long period ;
	char date[128] ;

	time_t debut,fin ; 


	/* Pseudo Runtime stats */
	time(&debut);


	/* Prints Content-Type */
	printf("%s%c%c\n","Content-Type:text/html;charset=iso-8859-1",13,10);
  	
	/* Check for config file */
	if (existfile("happystats.conf","r") == 0)
  		CGIWorld.configfile=xstrdup("happystats.conf");
#ifdef __linux__
	else if (existfile("/etc/happystats.conf","r") == 0) 
  		CGIWorld.configfile=xstrdup("/etc/happystats.conf");
#else
	else if (existfile("/usr/local/etc/happystats.conf","r") == 0)
  		CGIWorld.configfile=xstrdup("/usr/local/etc/happystats.conf");
#endif 
	else 
		_error(1,"No config file found");
	

	/* Get (XML)conf */
	CGI_Init_World() ;


	/* Get environment variables */
	form = getenv("QUERY_STRING");
	url = getenv("SCRIPT_NAME");


	/* argh !!! rewrite this !!!  */
	
	if(form == NULL || strcmp(form,"") == 0 ) 
	{
			period = day ;/* CGIWorld.default_view ; */
			time(&cur_time);
	}
	else {

			if (sscanf(form,"period=%lu&time=%d",&period,&cur_time) == 2)
			{
			}
			else if (sscanf(form,"period=%lu",&period) == 1)
			{
				time(&cur_time);
			}
			else 
			{ 
				period = day ; 
				time(&cur_time);
			}
	}
	
	prev_time = (int)cur_time - period ;
	next_time = (int)cur_time + period ;

	printf ("<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n");
	printf ("<html>\n<head>\n");
	printf ("<meta http-equiv=\"content-type\" content=\"application/xhtml+xml; charset=utf-8\">\n");

	/* Include Css file */
	printf ("<link rel=\"stylesheet\" type=\"text/css\" href=\"%s\" title=\"Happystats stylesheet\">\n",CGIWorld.cssfile);

	/* Title */
	printf ("<title>HappyStats</title>\n</head>\n");

	/* Body */
	printf("<body>\n<div id=\"top\"></div>\n<div id=\"header\">\n<span class=\"headerTitle\">Happystats</span>\n");
	printf("<div class=\"menuBar\">:: <a href=\"%s?period=%lu\">Day</a> :: <a href=\"%s?period=%lu\">Week</a> :: <a href=\"%s?period=%lu\">Month</a> :: <a href=\"%s?period=%lu\">Year</a> ::</div>\n",url, day, url, week, url, month, url, year);

	printf("<div class=\"menuBarRight\">\n");

	
	if (period == week)
	{
		if (prev_time > ((int)time(NULL) - (week * 5)) )
			printf("<a href=\"%s?period=%lu&time=%lu\">&lt; &lt;</a>",url, period ,prev_time); 

		strftime(date,128,"Week %W %B %Y",localtime(&cur_time)) ;

	}
	else if (period == month)
	{

		if (prev_time > ((int)time(NULL) - (month * 13)) )
			printf("<a href=\"%s?period=%lu&time=%lu\">&lt; &lt;</a>",url, period ,prev_time); 
		
		strftime(date,128,"%B %Y",localtime(&cur_time)) ;
	}
	else if (period == year)
	{

		if (prev_time > ((int)time(NULL) - (year * 3)) )
			printf("<a href=\"%s?period=%lu&time=%lu\">&lt; &lt;</a>",url, period ,prev_time); 
			
		strftime(date,128,"Year %Y",localtime(&cur_time)) ;

	}
	else
	{
		if (prev_time > ((int)time(NULL) - (day * 9)) )
			printf("<a href=\"%s?period=%lu&time=%lu\">&lt; &lt;</a>",url, period ,prev_time); 
			
		strftime(date,128,"%A %d %B %Y",localtime(&cur_time)) ;

	}
	
	printf(" &nbsp; %s &nbsp;",date);
	
	if (next_time <= (int)time(NULL) )
		printf("<a href=\"%s?period=%lu&time=%lu\">&gt; &gt;</a>",url, period ,next_time);
	
	



	printf("</div>\n</div>\n");


	/* Menu */
	graph = CGIWorld.graph ;

	printf("<!-- NBGRAPHS %d-->\n",CGIWorld.nbGraph);

	T = CGIWorld.nbGraph ;

	printf ("<div class=\"sideBox LHS\">\n<div>:: Graphs Menu ::</div>\n");

	for (X = 0; X < T ;X++) {
		printf ("<a href=\"#graph_%d\">&rsaquo; %s </a>",X,graph->title);
		graph = graph->next ;
	}

	printf("</div>");


	/* Powered by stuff */
	printf ("<div class=\"sideBox LHS\">\n<div>:: Powered by ::</div>\n<a href=\"http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/\">\n");

	printf ("<IMG height=\"34px\" width=\"120px\" border=\"0\" src=\"http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/.pics/rrdtool.gif\" ALT=\"[rrdtool logo]\"></a>\n\n");
	printf ("<a href=\"http://www.xmlsoft.org\"><IMG height=\"34px:\" width=\"120px\" border=\"0\" src=\"http://xmlsoft.org/Libxml2-Logo-180x168.gif\" ALT=\"[libxml logo]\"></a>\n</div>\n");
	

	/* Graphs */
	printf("<div id=\"bodyText\">\n");
	graph = CGIWorld.graph ;
	T = CGIWorld.nbGraph ;

	/* Check for rrdfiles */
	for (X = 0; X < T ;X++) {

		if (X >= 2) {
			printf("<P><A class=\"topOfPage\" href=\"#top\" title=\"Top Of Page\">top</A></P>\n"); 
		}

		printf("<h1 id=\"graph_%d\">%s</h1>\n<p>\n",X,graph->title);
		
		sprintf(outputimg,"happystats_%lu_%d_%d.png",period,cur_time,X);
		
		rc = RRDGraph(graph,outputimg,period,(cur_time - period),cur_time) ;
		
		printf("</p><BR><BR>\n");
		
		graph = graph->next ;
		
	  	/* free(outputimg); */
	}
	
	/**/
	time(&fin);
	
	printf ("</div>\n<div id=\"footer\">\n<div class=\"footerLHS\"><a href=\"http://happystats.org/\">Happystats V-%s (in %d secs)</a></div>",VERSION,(int)(fin - debut));

	printf("<div>Copyleft ;) Olivier Fredj 2004\n</div></div></body></html>\n");

	/* Free Values */
	CGI_Free_World();

	/* free(period); */
	
	return(0);
}

