/********************************************************************************/
/*                                                                              */
/*     Happystats $Id: cgi.h,v 1.3 2004/02/06 15:10:58 ofredj Exp $			*/
/*                                                                              */
/*     This program is free software; you can redistribute it and/or modify     */
/*     it under the terms of the GNU General Public License as published by     */
/*     the Free Software Foundation; either version 2 of the License, or        */
/*     (at your option) any later version.                                      */
/*                                                                              */
/*     This program is distributed in the hope that it will be useful,          */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            */
/*     GNU General Public License for more details.                             */
/*                                                                              */
/*     You should have received a copy of the GNU General Public License        */
/*     along with this program; if not, write to the Free Software              */
/*     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                */
/*                                                                              */
/********************************************************************************/

/* Includes */
#define MAXDSPERGRAPH 32    /* Max DS that we will handle  */
#define MAXGRAPH 64    		/* Max DS that we will handle  */

/* Those values are overiden by config ones */
#define DEFAULT_GRAPH_WIDTH 540 /* Default graph width */
#define DEFAULT_GRAPH_HEIGHT 150 /* Default graph height  */

/* 
 * Structures 
 */

/* struct for a ds (member of a graph) */
typedef struct graphDs { 
	
	char *dsname ; 			/* name of the ds to plot  */
	char *rrdfile ;			/* rrdfile associated with him */
	char *type ;			/* type of plop (line/area) */
	char *color ;			/* color in hexidecial */
	char *legend ;			/* legend */
	char *short_legend ;	/* short legend	*/
	
	/* Ptr to the next struct */
	struct graphDs	*next ;

} graphDs, *graphDsPtr ;


/* Graph stuct */
typedef struct graph { 

	char *title ; 			/* Title of the graph  	*/
	char *vertical_label ;	/* Vertical legend 		*/
	char *time_unit ;		/* Unit de temps */

	/* DS Chained lists */
	graphDsPtr ds ; 		/* Chained list itself	*/
	u_short nbDs ; 			/* compteur 			*/
	
	/* Ptr to the next struct */
	struct graph *next ;

} graph, *graphPtr;


/* CGI_world Main Struct */
struct CGI_world {

	/* Gloabal Options */
	u_short step ; 			/* RRDStep 	*/
	u_short width ;			/* Width	*/
	u_short height ;		/* Height	*/
	char *outputdir ; 		/* Path to the img output directory */
	char *cssfile ; 		/* Path to the CSS file*/
	char *configfile ; 		/* Path to the configfile */
	char *imgformat ;		/* Image format (png|jpeg) */
	char *includedir ;  	/* Path relative to the root of webserver for img inclusion in html */
	char *default_view ;	/* Default view for CGI (day/week/month) */
	
	/* Chained lists */
	u_short nbGraph ;		/* Nb of graph in chained list (get from configfile )*/
	graphPtr graph;			/* Graph chained list */
	
} CGIWorld ;

/* Prototypes */
void CGI_Init_World() ;
void CGI_Free_World() ;
void CGI_Print_World() ;
int RRDGraph (graphPtr graph,char *filename,u_long period,u_long start,u_long end);
