/********************************************************************************/
/*                                                                              */
/*     Happystats $Id: date.c,v 1.1.1.1 2003/11/15 16:04:54 ofredj Exp $	*/
/*                                                                              */
/*     This program is free software; you can redistribute it and/or modify     */
/*     it under the terms of the GNU General Public License as published by     */
/*     the Free Software Foundation; either version 2 of the License, or        */
/*     (at your option) any later version.                                      */
/*                                                                              */
/*     This program is distributed in the hope that it will be useful,          */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            */
/*     GNU General Public License for more details.                             */
/*                                                                              */
/*     You should have received a copy of the GNU General Public License        */
/*     along with this program; if not, write to the Free Software              */
/*     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                */
/*                                                                              */
/********************************************************************************/

#include "happystats.h"

const char *months[12] = {
  "Jan", "Feb", "Mar", "Apr", "May", "Jun",
  "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};

/* TODO :: faire du tolower sur le monthtoatoi */

/* Convert a 3 charachter month to an int */
u_short monthatoi (char *month) {
  
	short int i, ret=1;
	
	/* Check if arg seems good */
	if (strlen(month) != 3)
		return 0;

	/* Compare the given string whith our const *char[] */
	for (i=0;ret; i++) {
		ret=strncmp(month,months[i],3);
	}

	/* if not found in the array return 0 */
	if (ret) { 
			i = 0 ;
	} else { 
		i--; 
	}

	return(i);
}

u_long date2timestamp (int day,int month,int year,int hour,int minute,int second) 
{
  struct tm *timestamp;
  u_long ret;
  time_t tval;

  time(&tval);
  timestamp = localtime(&tval);
  timestamp->tm_sec=second;	/* Seconds.	[0-60] (1 leap second) */
  timestamp->tm_min=minute;	/* Minutes.	[0-59] */
  timestamp->tm_hour=hour;	/* Hours.	[0-23] */
  timestamp->tm_mday=day;	/* Day.		[1-31] */
  timestamp->tm_mon=month ;	/* Month.	[0-11] */
  if (year != 0) 
	timestamp->tm_year=(year - 1900);
  ret=mktime(timestamp) ;
  return (ret);
}
