/********************************************************************************/
/*                                                                              */
/*     Happystats $Id: exim.c,v 1.2 2004/01/24 00:23:53 ofredj Exp $		*/
/*                                                                              */
/*     This program is free software; you can redistribute it and/or modify     */
/*     it under the terms of the GNU General Public License as published by     */
/*     the Free Software Foundation; either version 2 of the License, or        */
/*     (at your option) any later version.                                      */
/*                                                                              */
/*     This program is distributed in the hope that it will be useful,          */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            */
/*     GNU General Public License for more details.                             */
/*                                                                              */
/*     You should have received a copy of the GNU General Public License        */
/*     along with this program; if not, write to the Free Software              */
/*     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                */
/*                                                                              */
/********************************************************************************/

/* Includes */
#include "happystats.h"

int Parse_Exim(char *logline) {
  
  int ovector[OVECCOUNT];
  unsigned int rc, month, day, year, hour, min, sec ;
  char *tmp ;


  /* match the regexp in the logline */
  rc = pcre_exec(
		 World.Parser_Rule,          /* the compiled pattern */
		 NULL,        /* we didn't study the pattern */
		 logline,     /* the subject string */
		 (int)strlen(logline), /* the length of the subject */
		 0,           /* start at offset 0 in the subject */
		 0,           /* default options */
		 ovector,     /* vector for substring information */
		 OVECCOUNT);  /* number of elements in the vector */

  if (rc <= 0 ) {
    return(1) ;
  } else {

    /* Make a timestamp from the logline */

    /* year */
    tmp = fetch_substrings(logline,ovector,1) ;
    year = atoi(tmp);
    free(tmp);

    /* month */
    tmp = fetch_substrings(logline,ovector,2) ;
    month = atoi(tmp);
    free(tmp);

    /* day_of_month */
    tmp = fetch_substrings(logline,ovector,3);
    day=atoi(tmp);
    free(tmp);

    /* hour */
    tmp=fetch_substrings(logline,ovector,4);
    hour=atoi(tmp);
    free(tmp);

    /* minute */
    tmp=fetch_substrings(logline,ovector,5);
    min=atoi(tmp);
    free(tmp);

    /* second */
    tmp=fetch_substrings(logline,ovector,6);
    sec=atoi(tmp);
    free(tmp);

    /* Register the values in the output struct */
    
    World.parsedline.timestamp = date2timestamp(day,month,year,hour,min,sec);
    
    
    World.parsedline.action = fetch_substrings(logline,ovector,7);
	
	/* Program && Hostname are NULL */
    World.parsedline.program = NULL ;
	World.parsedline.hostname = NULL ;

    return(0) ;
  }
}

void Compile_Exim_Rule() {
  
  /* The ims splitter : a regexp to split syslog into : timestamp , host , program , action */
  /* 2003-11-07 15:30:23 19Q6EI-0004J6-00 Message is frozen */
  char pattern[] ="^(\\d{4})-(\\d{2})-(\\d{2})\\s(\\d{2})\\:(\\d{2})\\:(\\d{2})\\s(.*)$";
  
  World.Parser_Rule = NULL ;
  
  /* Compile the regular expression in the first argument */
  World.Parser_Rule = regcomp(pattern);
  
  if (World.Parser_Rule == NULL)
    _error(-1,"E: happystats can't compile exim rule ");

}
