/********************************************************************************/
/*                                                                              */
/*     Happystats $Id: file.c,v 1.1.1.1 2003/11/15 16:04:54 ofredj Exp $		*/
/*                                                                              */
/*     This program is free software; you can redistribute it and/or modify     */
/*     it under the terms of the GNU General Public License as published by     */
/*     the Free Software Foundation; either version 2 of the License, or        */
/*     (at your option) any later version.                                      */
/*                                                                              */
/*     This program is distributed in the hope that it will be useful,          */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            */
/*     GNU General Public License for more details.                             */
/*                                                                              */
/*     You should have received a copy of the GNU General Public License        */
/*     along with this program; if not, write to the Free Software              */
/*     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                */
/*                                                                              */
/********************************************************************************/


/* Includes */
#include "happystats.h"

/* Open the file given in argument and return a structure */
int Open_fh() {
  World.fh.fd = fopen(World.logfile,"r");
  if (!World.fh.fd){
	_debug(1,errno,"Can't open %s for reading .",World.logfile);
    return(1);
  } else {
    World.fh.filedesc = fileno(World.fh.fd);
    World.fh.position = ftell(World.fh.fd);
    return(0) ;
  }
}

/* get a line from a given filehandle */
int Read_fh() {

  if (strcmp(World.logfile,"stdin") == 0 ) {
    fgets(World.fh.line,_POSIX2_LINE_MAX,stdin) ;
    if (ferror(stdin)) {
	 _error(errno,"Read error");
    }
    return(feof(stdin));
  } else { 
  	fgets(World.fh.line,_POSIX2_LINE_MAX, World.fh.fd ) ;
  	World.fh.position = ftell(World.fh.fd);
    return(feof(World.fh.fd));
  }
}

/* Close the filehandle / free the structure */
int Close_fh() {
  int ret ;
  ret=fclose(World.fh.fd) ; 
  return(ret);
}

/*  Check if rrd file exists and is writable */
int existfile(char *filename,const char *attr) {
  FILE *test = fopen(filename,attr) ;
  if (test == NULL) {
    _debug(1, errno, "Can't open '%s' in %s mode", filename, attr)  ;
    return(1);
  } else {
    fclose(test);
    return(0);
  }
}


/* Re-open the filehandle for tail mode */
/* Yeah I known this is very Dirty !! 
 * Not use at the moment */
int re_open(struct filehandle *FH,char *file) {
  int rc ;
  fclose(FH->fd);
  FH->fd = fopen(file,"r");
  if (!FH->fd) 	{
    perror("happystats");
    exit(1);
  }
  rc=lseek(FH->filedesc,FH->position,SEEK_SET);
  return(0) ;
}

