/* Includes */
#include "happystats.h"
#include "cgi.h"

int RRDGraph (graphPtr graph,char *filename,u_long period,u_long start,u_long end)
{ 

	int  rrdargc , i = 0  , j = 0 , rc  = 0 , line = 2  ; 
	char *rrdcmd[256] ;
	graphDsPtr ds ;
	time_t tval;
	char *curdate ;
	char **calcpr;
	int xsize, ysize ; 
	/* int  end ; */

	short unit_sec ;

	int step = period * POINTS_PER_SAMPLE / CGIWorld.width  ;

	/* Set unit */
	if (strcmp(graph->time_unit,"sec") == 0 )
		unit_sec=1;
	else if (strcmp(graph->time_unit,"min") == 0 )
		unit_sec=60;
	else if	(strcmp(graph->time_unit,"hour") == 0 )
		unit_sec=3600;
	else {
		unit_sec=60;
		free(graph->time_unit); graph->time_unit = xstrdup ("min");
	}


	/* Get the time */
  	time(&tval);
	curdate = (char *)malloc(sizeof(char)*(MAX_INT_STR));
	curdate = ctime(&tval) ;

	curdate[(strlen(curdate) - 1 )] = '\0' ; 

	/* Set minimal argc */
	rrdargc=(graph->nbDs * 10) + 15 ;

	rrdcmd[i] = xstrdup ("graph");
		
  	/* Set filename */		
	i++ ;
	rrdcmd[i] = (char *)malloc(sizeof(char)*(strlen(filename)+strlen(CGIWorld.outputdir)+3));
  	checkmalloc(rrdcmd[i]);
	sprintf(rrdcmd[i],"%s/%s",CGIWorld.outputdir,filename) ;
	
	/* -- lazy Options ! */
	/*
	i++;
	rrdcmd[i] = xstrdup ("--lazy");
	
	*/

	/* Imgformat */
	i++ ;
	rrdcmd[i] = xstrdup ("--imgformat");
	
	i++ ;
 	rrdcmd[i] = (char *)malloc(sizeof(char)*(strlen(CGIWorld.imgformat)+1));
  	checkmalloc(rrdcmd[i]);
	strcpy(rrdcmd[i],CGIWorld.imgformat) ;

	
	/* Width */
	i++;
	rrdcmd[i] = xstrdup ("--width");
	i++ ;
	rrdcmd[i] = (char *)malloc(sizeof(char)*(MAX_INT_STR));
	checkmalloc(rrdcmd[i]);
	sprintf(rrdcmd[i],"%d",CGIWorld.width); 


	/* Height */
	i++;
	rrdcmd[i] = xstrdup ("--height");
	i++;
	rrdcmd[i] = (char *)malloc(sizeof(char)*(MAX_INT_STR));
	checkmalloc(rrdcmd[i]);
	sprintf(rrdcmd[i],"%d",CGIWorld.height); 

	
	/* Start */
	i++;
	rrdcmd[i] = xstrdup ("--start");
	i++;
	rrdcmd[i] = (char *)malloc(sizeof(char)*(MAX_INT_STR));
	checkmalloc(rrdcmd[i]);
	if (start)
		sprintf(rrdcmd[i],"%lu",start); 
	else
		sprintf(rrdcmd[i],"-%lu",period); 
	
	
	/* END  */
	i++;
	rrdcmd[i] = xstrdup ("--end");
	i++;
	rrdcmd[i] = (char *)malloc(sizeof(char)*(MAX_INT_STR));
	checkmalloc(rrdcmd[i]);
	if (end)
		sprintf(rrdcmd[i],"%lu",end); 
	else 
		sprintf(rrdcmd[i],"-%d",(int)(period * 0.01)); 

	/* Title */
	/*
	if (graph->title != NULL) 
	{
		i++;
		rrdcmd[i] = xstrdup ("--title");
		i++;
 		rrdcmd[i] = (char *)malloc(sizeof(char)*(strlen(graph->title)+1));
  		checkmalloc(rrdcmd[i]);
		strcpy(rrdcmd[i],graph->title) ;
		rrdargc += 2 ;
	}*/
	
	
	/* Vertical Label */
	if (graph->vertical_label != NULL) 
	{
		i++;
		rrdcmd[i] = xstrdup ("--vertical-label");
		i++ ;
 		rrdcmd[i] = (char *)malloc(sizeof(char)*(strlen(graph->vertical_label)+1));
  		checkmalloc(rrdcmd[i]);
		strcpy(rrdcmd[i],graph->vertical_label) ;
		rrdargc += 2 ;
	}
	
	printf("<!-- Start DS Section -->\n");

	/* Now Add lines for each DS ! */

	ds = graph->ds ;

	for (j=0; j < graph->nbDs ;j++) 
	{ 
		
		/* ds = graph->ds[j] ; */


		i++ ;
 		rrdcmd[i] = (char *)malloc(sizeof(char) * ( (strlen(ds->dsname) * 2) + strlen(ds->rrdfile) + strlen("DEF:=::AVERAGE") + MAX_INT_STR) );
  		checkmalloc(rrdcmd[i]);
		sprintf(rrdcmd[i] ,"DEF:%s=%s:%s:AVERAGE",ds->dsname,ds->rrdfile,ds->dsname) ;
		
 		
		i++;
		rrdcmd[i] = (char *)malloc(sizeof(char) * ( (strlen(ds->dsname) * 2) + strlen(ds->rrdfile) + strlen("DEF:b=::MAX") + MAX_INT_STR  ) );
  		checkmalloc(rrdcmd[i]);
		sprintf(rrdcmd[i] ,"DEF:b%s=%s:%s:MAX",ds->dsname,ds->rrdfile,ds->dsname) ;
		
		
		i++ ;
		rrdcmd[i] = (char *)malloc(sizeof(char) * ( (strlen(ds->dsname) * 2) + strlen("CDEF:c=,60,*") + MAX_INT_STR) );
  		checkmalloc(rrdcmd[i]);
		sprintf(rrdcmd[i] ,"CDEF:c%s=%s,%d,*",ds->dsname,ds->dsname,unit_sec) ;
		

		i++ ;
		rrdcmd[i] = (char *)malloc(sizeof(char) * ( (strlen(ds->dsname) * 2) + strlen("CDEF:d=b,60,*") + MAX_INT_STR) );
  		checkmalloc(rrdcmd[i]);
		sprintf(rrdcmd[i] ,"CDEF:d%s=b%s,%d,*",ds->dsname,ds->dsname,unit_sec) ;

		i++ ;
		rrdcmd[i] = (char *)malloc(sizeof(char) * ( (strlen(ds->dsname) * 3) + MAX_INT_STR  + strlen("CDEF:e=,UN,0,,IF,,*") + MAX_INT_STR ) );
  		checkmalloc(rrdcmd[i]);
		sprintf(rrdcmd[i] ,"CDEF:e%s=%s,UN,0,%s,IF,%d,*",ds->dsname,ds->dsname,ds->dsname,step) ;
		
		i++;
		rrdcmd[i] = (char *)malloc(sizeof(char) * ( (strlen(ds->dsname) * 3) + strlen("CDEF:f=PREV,UN,e,PREV,IF,e,+") + MAX_INT_STR ) );
  		checkmalloc(rrdcmd[i]);
		sprintf(rrdcmd[i] ,"CDEF:f%s=PREV,UN,e%s,PREV,IF,e%s,+",ds->dsname,ds->dsname,ds->dsname) ;



		/* AREA || LINE ? */
		i++;

		if (strcmp("LINE",ds->type) == 0 ) 
		{
		
			rrdcmd[i] = (char *)malloc(sizeof(char) * ( strlen(ds->color) + strlen(ds->dsname) + strlen(ds->legend) + MAX_INT_STR + strlen("LINE:c:") + MAX_INT_STR) );
			checkmalloc(rrdcmd[i]);
			sprintf(rrdcmd[i] ,"LINE%d:c%s%s:%s",line,ds->dsname,ds->color,ds->legend) ;
		} else {
			rrdcmd[i] = (char *)malloc(sizeof(char) * ( strlen(ds->color) + strlen(ds->dsname) + strlen(ds->legend) + strlen("AREA:c:") + MAX_INT_STR) );
			checkmalloc(rrdcmd[i]);
			sprintf(rrdcmd[i] ,"AREA:c%s%s:%s",ds->dsname,ds->color,ds->legend) ;
		}

		i++ ;
		rrdcmd[i] = (char *)malloc(sizeof(char) * ( strlen(ds->dsname) + strlen(ds->short_legend)  + strlen("GPRINT:f:MAX:total: .0lf ") +  MAX_INT_STR) );
  		checkmalloc(rrdcmd[i]);
		/* sprintf(rrdcmd[i] ,"GPRINT:f%s:MAX:total\\: %c.0lf %s",ds->dsname,'%',ds->short_legend) ; */
		sprintf(rrdcmd[i] ,"GPRINT:f%s:MAX: total\\: %c.0lf %s",ds->dsname,'%',ds->short_legend) ;
		
		
		i++ ;
		rrdcmd[i] = (char *)malloc(sizeof(char) * ( strlen(ds->dsname) + strlen(ds->short_legend) + strlen("GPRINT:d:MAX:max\\: .0lf ") + MAX_INT_STR ) );
		checkmalloc(rrdcmd[i]);
		sprintf(rrdcmd[i] ,"GPRINT:d%s:MAX:max\\: %c.0lf %s/%s",ds->dsname,'%',ds->short_legend,graph->time_unit) ;

		
		i++ ;
		rrdcmd[i] = (char *)malloc( sizeof(char) *( strlen(ds->dsname) + strlen(ds->short_legend) + strlen("GPRINT:c:AVERAGE:average\\: .2lf  \\l") + MAX_INT_STR) );
  		checkmalloc(rrdcmd[i]);
		sprintf(rrdcmd[i] ,"GPRINT:c%s:AVERAGE:average\\: %c.2lf %s/%s \\j",ds->dsname,'%',ds->short_legend,graph->time_unit) ;

		ds = ds->next ;

	}
		
	i++;
	rrdcmd[i] = xstrdup ("HRULE:0#000000");
	i++;
	rrdcmd[i] = xstrdup ("COMMENT:\\n");

	i++ ;
	rrdcmd[i] = (char *)malloc(sizeof(char)*(_POSIX2_LINE_MAX));
	checkmalloc(rrdcmd[i]);
	sprintf(rrdcmd[i],"COMMENT:graph created on %s\\n",curdate); 
	
	/* Print out the command */
	/* for (j = 0 ; j < rrdargc ; j++) {  
		if (rrdcmd[j] != NULL )
	    		printf ("<!-- DEBUG: %d %s -->\n",j,rrdcmd[j]); 
	} */
	    		
	
	/* Create Graph from rrd file and config */
	optind = 0;
	rrd_clear_error();
	rc = rrd_graph(rrdargc,rrdcmd,&calcpr, &xsize, &ysize);
    
    
	/* Check for Errors */
	if (rc)
		_debug(1, errno, "Can't create Graph '%s': %s", filename, rrd_get_error());
	else 
		printf("<IMG SRC=\"%s/%s\" BORDER=\"0\" ALT=\"[graph]\">\n",CGIWorld.includedir,filename);

    
	/* Free rrdarg */
	for (i = 0 ; i < rrdargc ; i++) {  
		free(rrdcmd[i]); 
	}
	
	/* free(curdate) ; */

	/* Return Output */
	return(rc);

}
