/********************************************************************************/
/*                                                                              */
/*     Happystats $Id: syslog.c,v 1.3 2004/02/06 14:34:51 ofredj Exp $		*/
/*                                                                              */
/*     This program is free software; you can redistribute it and/or modify     */
/*     it under the terms of the GNU General Public License as published by     */
/*     the Free Software Foundation; either version 2 of the License, or        */
/*     (at your option) any later version.                                      */
/*                                                                              */
/*     This program is distributed in the hope that it will be useful,          */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            */
/*     GNU General Public License for more details.                             */
/*                                                                              */
/*     You should have received a copy of the GNU General Public License        */
/*     along with this program; if not, write to the Free Software              */
/*     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                */
/*                                                                              */
/********************************************************************************/

/* Includes */
#include "happystats.h"

int Parse_Syslog(char *logline) {
  
  int ovector[OVECCOUNT];
  unsigned short int rc, month , day , hour , min , sec ;
  char *tmp ;


  /* match the regexp in the logline */
  rc = pcre_exec(
		 World.Parser_Rule,          /* the compiled pattern */
		 NULL,        /* we didn't study the pattern */
		 logline,     /* the subject string */
		 (int)strlen(logline), /* the length of the subject */
		 0,           /* start at offset 0 in the subject */
		 0,           /* default options */
		 ovector,     /* vector for substring information */
		 OVECCOUNT);  /* number of elements in the vector */

  if (rc <= 0 ) {
    return(1) ;
  } else {

    /* Make a timestamp from the logline */

    /* month */
    tmp = fetch_substrings(logline,ovector,1) ;
    month=monthatoi(tmp);
    free(tmp);

    /* day_of_month */
    tmp = fetch_substrings(logline,ovector,2);
    day=atoi(tmp);
    free(tmp);

    /* hour */
    tmp=fetch_substrings(logline,ovector,3);
    hour=atoi(tmp);
    free(tmp);

    /* minute */
    tmp=fetch_substrings(logline,ovector,4);
    min=atoi(tmp);
    free(tmp);

    /* second */
    tmp=fetch_substrings(logline,ovector,5);
    sec=atoi(tmp);
    free(tmp);

    /* Register the values in the output struct */
    
    World.parsedline.timestamp=date2timestamp(day,month,World.year,hour,min,sec);
    
    World.parsedline.hostname=fetch_substrings(logline,ovector,6);
    
    World.parsedline.program=fetch_substrings(logline,ovector,7);
    
    World.parsedline.action=fetch_substrings(logline,ovector,8);

    return(0) ;
  }
}



void Compile_Syslog_Rule() {
  
  /* The syslog splitter : a regexp to split syslog into : timestamp , host , program , action */
  char pattern[] ="^(\\w{3})\\s{1,2}(\\d{1,2})\\s(\\d{2})\\:(\\d{2})\\:(\\d{2}) \
	       		 \\s(\\S+?)\
			     (?:/\\S+)?\
			     \\s+\
			     ([^:]+?)\
			     (?:\\[\\d+\\])?\
			     \\:\\s+\
			     (?:\\[ID\\s\\d+\\s[a-z0-9]+\\.[a-z]+\\]\\s)?\
			     (.*)$";

  
  World.Parser_Rule = NULL ;
  
  /* Compile the regular expression in the first argument */
  World.Parser_Rule = regcomp(pattern);
  
  if (World.Parser_Rule == NULL)
    _error(-1,"E: happystats can't compile syslog rule");

}
